## volk 3.1.2

=== docs/CMakeLists.txt ===
# -*- coding: utf-8 -*-
#
# Copyright 2022 Johannes Demel.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#

find_package(Doxygen)
if(DOXYGEN_FOUND)

    message(STATUS "Doxygen found. Building docs ...")

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_BINARY_DIR}/Doxyfile
                   @ONLY)

    add_custom_target(
        volk_doc
        ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Generating documentation with Doxygen"
        VERBATIM)

endif(DOXYGEN_FOUND)

=== lib/CMakeLists.txt ===
#
# Copyright 2011-2012,2014,2018 Free Software Foundation, Inc.
#
# This file is part of VOLK.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#

########################################################################
# header file detection
########################################################################
include(CheckIncludeFile)
check_include_file(cpuid.h HAVE_CPUID_H)
if(HAVE_CPUID_H)
    add_definitions(-DHAVE_CPUID_H)
endif()

check_include_file(intrin.h HAVE_INTRIN_H)
if(HAVE_INTRIN_H)
    add_definitions(-DHAVE_INTRIN_H)
endif()

check_include_file(fenv.h HAVE_FENV_H)
if(HAVE_FENV_H)
    add_definitions(-DHAVE_FENV_H)
endif()

check_include_file(dlfcn.h HAVE_DLFCN_H)
if(HAVE_DLFCN_H)
    add_definitions(-DHAVE_DLFCN_H)
    list(APPEND volk_libraries ${CMAKE_DL_LIBS})
endif()

########################################################################
# Setup the compiler name
########################################################################
set(COMPILER_NAME ${CMAKE_C_COMPILER_ID})
if(MSVC) #its not set otherwise
    set(COMPILER_NAME MSVC)
endif()

# Assume "AppleClang == Clang".
string(TOLOWER ${COMPILER_NAME} COMPILER_NAME_LOWER)
string(REGEX MATCH "clang" COMPILER_NAME_LOWER ${COMPILER_NAME_LOWER})
if(${COMPILER_NAME_LOWER} MATCHES "clang")
    set(COMPILER_NAME "Clang")
endif()

message(STATUS "Compiler name: ${COMPILER_NAME}")

if(NOT DEFINED COMPILER_NAME)
    message(
        FATAL_ERROR "COMPILER_NAME undefined. Volk build may not support this compiler.")
endif()

########################################################################
# Special clang flag so flag checks can fail
########################################################################
if(COMPILER_NAME MATCHES "GNU")
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag("-Werror=unused-command-line-argument"
                            HAVE_WERROR_UNUSED_CMD_LINE_ARG)
    if(HAVE_WERROR_UNUSED_CMD_LINE_ARG)
        set(VOLK_FLAG_CHECK_FLAGS "-Werror=unused-command-line-argument")
    endif()
endif()

########################################################################
# POSIX_MEMALIGN: If we have to fall back to `posix_memalign`,
# make it known to the compiler.
########################################################################
if(HAVE_POSIX_MEMALIGN)
    message(STATUS "Use `posix_memalign` for aligned malloc!")
    add_definitions(-DHAVE_POSIX_MEMALIGN)
endif(HAVE_POSIX_MEMALIGN)

########################################################################
# detect x86 flavor of CPU
########################################################################
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^(i.86|x86|x86_64|amd64|AMD64)$")
    message(STATUS "x86* CPU detected")
    set(CPU_IS_x86 TRUE)
endif()

########################################################################
# determine passing architectures based on compile flag tests
########################################################################
execute_process(
    COMMAND
        ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
        ${PROJECT_SOURCE_DIR}/gen/volk_compile_utils.py --mode "arch_flags" --compiler
        "${COMPILER_NAME}"
    OUTPUT_VARIABLE arch_flag_lines
    OUTPUT_STRIP_TRAILING_WHITESPACE)

macro(check_arch arch_name)
    set(flags ${ARGN})
    set(have_${arch_name} TRUE)
    foreach(flag ${flags})
        if(MSVC AND (${flag} STREQUAL "/arch:SSE2" OR ${flag} STREQUAL "/arch:SSE"))
            # SSE/SSE2 is supported in MSVC since VS 2005 but flag not available when compiling 64-bit so do not check
        else()
            include(CheckCXXCompilerFlag)
            set(have_flag have${flag})
            #make the have_flag have nice alphanum chars (just for looks/not necessary)
            execute_process(
                COMMAND ${PYTHON_EXECUTABLE} -c
                        "import re; print(re.sub('\\W', '_', '${have_flag}'))"
                OUTPUT_VARIABLE have_flag
                OUTPUT_STRIP_TRAILING_WHITESPACE)
            if(VOLK_FLAG_CHECK_FLAGS)
                set(CMAKE_REQUIRED_FLAGS ${VOLK_FLAG_CHECK_FLAGS})
            endif()
            check_cxx_compiler_flag(${flag} ${have_flag})
            unset(CMAKE_REQUIRED_FLAGS)
            if(NOT ${have_flag})
                set(have_${arch_name} FALSE)
            endif()
        endif()
    endforeach()
    if(have_${arch_name})
        list(APPEND available_archs ${arch_name})
    endif()
endmacro(check_arch)

foreach(line ${arch_flag_lines})
    string(REGEX REPLACE "," ";" arch_flags ${line})
    check_arch(${arch_flags})
endforeach(line)

macro(OVERRULE_ARCH arch reason)
    message(STATUS "${reason}, Overruled arch ${arch}")
    list(REMOVE_ITEM available_archs ${arch})
endmacro(OVERRULE_ARCH)

macro(FORCE_ARCH arch reason)
    message(STATUS "${reason}, Forced arch ${arch}")
    list(APPEND available_archs ${arch})
endmacro(FORCE_ARCH)

########################################################################
# eliminate AVX on if not on x86, or if the compiler does not accept
# the xgetbv instruction, or {if not cross-compiling and the xgetbv
# executable does not function correctly}.
########################################################################
set(HAVE_AVX_CVTPI32_PS 0)
if(CPU_IS_x86)
    #########################################################################
    # eliminate AVX if cvtpi32_ps intrinsic fails like some versions of clang
    #########################################################################

    # check to see if the compiler/linker works with cvtpi32_ps instrinsic when using AVX
    if(CMAKE_SIZEOF_VOID_P EQUAL 4)
        file(
            WRITE ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps.c
            "#include <immintrin.h>\nint main (void) {__m128 __a; __m64 __b; __m128 foo = _mm_cvtpi32_ps(__a, __b); return (0); }"
        )
        execute_process(
            COMMAND
                ${CMAKE_C_COMPILER} -mavx -o ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps
                ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps.c
            OUTPUT_QUIET ERROR_QUIET
            RESULT_VARIABLE avx_compile_result)
        if(NOT ${avx_compile_result} EQUAL 0)
            overrule_arch(avx "Compiler missing cvtpi32_ps instrinsic")
        else()
            set(HAVE_AVX_CVTPI32_PS 1)
        endif()
        file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps
             ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps.c)
    else(CMAKE_SIZEOF_VOID_P EQUAL 4)
        # 64-bit compilations won't need this command so don't overrule AVX
        set(HAVE_AVX_CVTPI32_PS 0)
    endif(CMAKE_SIZEOF_VOID_P EQUAL 4)

    # Disable SSE4a if Clang is less than version 3.2
    if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
        # Figure out the version of Clang

        if(CMAKE_C_COMPILER_VERSION VERSION_LESS "3.2")
            overrule_arch(sse4_a "Clang >= 3.2 required for SSE4a")
        endif(CMAKE_C_COMPILER_VERSION VERSION_LESS "3.2")
    endif("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")

endif(CPU_IS_x86)

if(${HAVE_AVX_CVTPI32_PS})
    add_definitions(-DHAVE_AVX_CVTPI32_PS)
endif()

########################################################################
# if the CPU is not x86, eliminate all Intel SIMD
########################################################################

if(NOT CPU_IS_x86)
    overrule_arch(3dnow "Architecture is not x86 or x86_64")
    overrule_arch(mmx "Architecture is not x86 or x86_64")
    overrule_arch(sse "Architecture is not x86 or x86_64")
    overrule_arch(sse2 "Architecture is not x86 or x86_64")
    overrule_arch(sse3 "Architecture is not x86 or x86_64")
    overrule_arch(ssse3 "Architecture is not x86 or x86_64")
    overrule_arch(sse4_a "Architecture is not x86 or x86_64")
    overrule_arch(sse4_1 "Architecture is not x86 or x86_64")
    overrule_arch(sse4_2 "Architecture is not x86 or x86_64")
    overrule_arch(avx "Architecture is not x86 or x86_64")
    overrule_arch(avx512f "Architecture is not x86 or x86_64")
    overrule_arch(avx512cd "Architecture is not x86 or x86_64")
endif(NOT CPU_IS_x86)

########################################################################
# Select neon based on ARM ISA version
########################################################################

# First, compile a test program to see if compiler supports neon.

include(CheckCSourceCompiles)

check_c_source_compiles(
    "#include <arm_neon.h>\nint main(){ uint8_t *dest; uint8x8_t res; vst1_u8(dest, res); }"
    neon_compile_result)

if(neon_compile_result)
    set(CMAKE_REQUIRED_INCLUDES ${PROJECT_SOURCE_DIR}/include)
    check_c_source_compiles(
        "#include <volk/volk_common.h>\n int main(){__VOLK_ASM(\"vrev32.8 q0, q0\");}"
        have_neonv7_result)
    check_c_source_compiles(
        "#include <volk/volk_common.h>\n int main(){__VOLK_ASM(\"sub v1.4s,v1.4s,v1.4s\");}"
        have_neonv8_result)

    if(NOT have_neonv7_result)
        overrule_arch(neonv7 "Compiler doesn't support neonv7")
    endif()

    if(NOT have_neonv8_result)
        overrule_arch(neonv8 "Compiler doesn't support neonv8")
    endif()
else(neon_compile_result)
    overrule_arch(neon "Compiler doesn't support NEON")
    overrule_arch(neonv7 "Compiler doesn't support NEON")
    overrule_arch(neonv8 "Compiler doesn't support NEON")
endif(neon_compile_result)

########################################################################
# implement overruling in the ORC case,
# since ORC always passes flag detection
########################################################################
if(NOT ORC_FOUND)
    overrule_arch(orc "ORC support not found")
endif()

########################################################################
# implement overruling in the non-multilib case
# this makes things work when both -m32 and -m64 pass
########################################################################
if(NOT CROSSCOMPILE_MULTILIB AND CPU_IS_x86)
    include(CheckTypeSize)
    check_type_size("void*[8]" SIZEOF_CPU BUILTIN_TYPES_ONLY)
    if(${SIZEOF_CPU} EQUAL 64)
        overrule_arch(32 "CPU width is 64 bits")
    endif()
    if(${SIZEOF_CPU} EQUAL 32)
        overrule_arch(64 "CPU width is 32 bits")
    endif()

    #MSVC 64 bit does not have MMX, overrule it
    if(MSVC)
        if(${SIZEOF_CPU} EQUAL 64)
            overrule_arch(mmx "No MMX for Win64")
        endif()
        force_arch(sse "Built-in for MSVC > 2013")
        force_arch(sse2 "Built-in for MSVC > 2013")
    endif()

endif()

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^riscv64$")
    message("---- Adding RISC-V ASM files")
    message("DEBUG: looking for ASM files in ${CMAKE_SOURCE_DIR}/kernels/volk/asm/riscv")
    include_directories(${CMAKE_SOURCE_DIR}/kernels/volk/asm/riscv)
    file(GLOB asm_files ${CMAKE_SOURCE_DIR}/kernels/volk/asm/riscv/*.s)
    foreach(asm_file ${asm_files})
        list(APPEND volk_sources ${asm_file})
        message(STATUS "Adding source file: ${asm_file}")
    endforeach(asm_file)
else()
    overrule_arch(riscv64 "machine is not riscv64")
endif()

########################################################################
# done overrules! print the result
########################################################################
message(STATUS "Available architectures: ${available_archs}")

########################################################################
# determine available machines given the available architectures
########################################################################
execute_process(
    COMMAND
        ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
        ${PROJECT_SOURCE_DIR}/gen/volk_compile_utils.py --mode "machines" --archs
        "${available_archs}"
    OUTPUT_VARIABLE available_machines
    OUTPUT_STRIP_TRAILING_WHITESPACE)

########################################################################
# Implement machine overruling for redundant machines:
# A machine is redundant when expansion rules occur,
# and the arch superset passes configuration checks.

=== debian/changelog ===
volk (3.1.2-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:26:19 +1100

volk (3.1.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063052

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 23:20:12 +0000

volk (3.1.2-1) unstable; urgency=medium

  * New upstream release.
    - Replace sse2neon with native NEON
    - Remove loop unrolling
    - Simplify Spiral-generated code

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 25 Feb 2024 08:51:33 -0500

=== debian/control ===
Source: volk
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               libcpu-features-dev [amd64 arm64 armel armhf i386 mips64el ppc64 ppc64el riscv64 s390x powerpc x32],
               liborc-0.4-dev [!x32],
               python3-dev,
               python3-mako
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://libvolk.org
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-volk
Vcs-Git: https://salsa.debian.org/bottoms/pkg-volk.git

Package: libvolk3.1t64
Provides: ${t64:Provides}
Replaces: libvolk3.1
Breaks: libvolk3.1 (<< ${source:Version})
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Recommends: libvolk-bin
Suggests: libvolk-dev
Description: vector optimized functions
 Vector-Optimized Library of Kernels is designed to help applications
 work with the processor's SIMD instruction sets. These are very
 powerful vector operations that can give signal processing a huge
 boost in performance.

Package: libvolk-dev
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libvolk3.1t64 (=${binary:Version}), ${misc:Depends}
Breaks: libvolk1-dev, libvolk1.0-dev, libvolk2-dev
Replaces: libvolk1-dev, libvolk1.0-dev, libvolk2-dev
Suggests: libvolk-doc
Multi-Arch: same
Description: vector optimized function headers
 Vector-Optimized Library of Kernels is designed to help applications
 work with the processor's SIMD instruction sets. These are very
 powerful vector operations that can give signal processing a huge
 boost in performance.
 .
 This package contains the header files.
 For documentation, see libvolk-doc.

Package: libvolk-bin
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libvolk3.1t64 (=${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Breaks: libvolk1-bin, libvolk1.0-bin, libvolk2-bin
Replaces: libvolk1-bin, libvolk1.0-bin, libvolk2-bin
Description: vector optimized runtime tools
 Vector-Optimized Library of Kernels is designed to help applications
 work with the processor's SIMD instruction sets. These are very
 powerful vector operations that can give signal processing a huge
 boost in performance.
 .
 This package includes: the volk_profile tool to customize settings for
 the system; volk_modtool to create new optimized modules; and
 volk-config-info to show settings.

Package: libvolk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: www-browser
Description: vector optimized library documentation
 Vector-Optimized Library of Kernels is designed to help applications
 work with the processor's SIMD instruction sets. These are very
 powerful vector operations that can give signal processing a huge
 boost in performance.
 .
 This package includes the Doxygen generated documentation in
 /usr/share/doc/libvolk-dev/html/index.html

=== debian/rules ===
#!/usr/bin/make -f
#export DEB_BUILD_MAINT_OPTIONS += hardening=+all
#export DH_VERBOSE=1

%:
	dh $@ --with python3

override_dh_auto_build-indep:
	cmake --build obj-* --target all
	cmake --build obj-* --target volk_doc
#	cmake --build obj-* --target volk_pdf_doc

override_dh_auto_install:
	dh_auto_install
	find debian -type d -empty -delete

override_dh_auto_clean:
	dh_auto_clean
	rm -rf gen/__pycache__

## volk 3.2.0

=== CMakeLists.txt ===
#
# Copyright 2011-2020 Free Software Foundation, Inc.
# Copyright 2023 Magnus Lundmark <magnuslundmark@gmail.com>
#
# This file is part of VOLK
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#

########################################################################
# Project setup
########################################################################
# We use `IS_64BIT now: https://cmake.org/cmake/help/latest/command/cmake_host_system_information.html
cmake_minimum_required(VERSION 3.10)

set(CMAKE_BUILD_TYPE
    ${CMAKE_BUILD_TYPE}
    CACHE STRING "Choose build type: None Debug Release RelWithDebInfo MinSizeRel")
project(volk)

enable_language(CXX)
enable_language(C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)

enable_testing()

########################################################################
# Common compile flags
########################################################################

# Disable complex math NaN/INFO range checking for performance
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-fcx-limited-range HAVE_CX_LIMITED_RANGE)
if(HAVE_CX_LIMITED_RANGE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fcx-limited-range")
endif(HAVE_CX_LIMITED_RANGE)

include(CheckCCompilerFlag)
check_c_compiler_flag(-fcx-limited-range HAVE_C_LIMITED_RANGE)
if(HAVE_C_LIMITED_RANGE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fcx-limited-range")
endif(HAVE_C_LIMITED_RANGE)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
add_definitions(-D_GLIBCXX_USE_CXX11_ABI=1)

if(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
    # Abort compilation if kernel implementations have inconsistent function
    # prototypes, i.e. if
    #
    #     kernel_foo_sse(uint32_t *dst, lv32fc_t *src)
    #     kernel_foo_avx(uint16_t *dst, lv32fc_t *src)
    #
    # are defined. Note the different data type of the first argument). By
    # default 'incompatible-pointer-types' is a warning only and 'pointer-sign'
    # is a warning enabled by '-Wall'. These warnings are only applicable to C.
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -Werror=incompatible-pointer-types -Werror=pointer-sign")
endif()

list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules
)#location for custom "Modules"

include(VolkBuildTypes)
#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS "Build type not specified: defaulting to release.")
endif()
volk_check_build_type(${CMAKE_BUILD_TYPE})
set(CMAKE_BUILD_TYPE
    ${CMAKE_BUILD_TYPE}
    CACHE STRING "")
message(STATUS "Build type set to ${CMAKE_BUILD_TYPE}.")

########################################################################
# Version setup
########################################################################

set(VERSION_INFO_MAJOR_VERSION 3)
set(VERSION_INFO_MINOR_VERSION 2)
set(VERSION_INFO_MAINT_VERSION 0)
include(VolkVersion) #setup version info

math(EXPR VOLK_VERSION_DECIMAL "${VERSION_INFO_MAJOR_VERSION} * 10000
    + ${VERSION_INFO_MINOR_VERSION} * 100
    + ${VERSION_INFO_MAINT_VERSION}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_version.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/include/volk/volk_version.h @ONLY)

########################################################################
# Environment setup
########################################################################
if(NOT DEFINED CROSSCOMPILE_MULTILIB)
    set(CROSSCOMPILE_MULTILIB "")
endif()
set(CROSSCOMPILE_MULTILIB
    ${CROSSCOMPILE_MULTILIB}
    CACHE
        STRING
        "Define \"true\" if you have and want to use multiple C development libs installed for cross compile"
)

if(MSVC)
    add_definitions(-D_USE_MATH_DEFINES
    )#enables math constants on all supported versions of MSVC
    add_compile_options(/W1) #reduce warnings
    add_compile_options(/wo4309)
    add_compile_options(/wd4752)
    add_compile_options(/wo4273)
    add_compile_options(/wo4838)
endif(MSVC)

########################################################################
# Dependencies setup
########################################################################

# cpu_features - sensible defaults, user settable option
if(CMAKE_SYSTEM_PROCESSOR MATCHES
   "(^mips)|(^arm)|(^aarch64)|(x86_64)|(AMD64|amd64)|(^i.86$)|(^powerpc)|(^ppc)|(^riscv)")
    option(VOLK_CPU_FEATURES "Volk uses cpu_features" ON)
else()
    option(VOLK_CPU_FEATURES "Volk uses cpu_features" OFF)
endif()

if(VOLK_CPU_FEATURES)
    find_package(CpuFeatures QUIET)
    if(NOT CpuFeatures_FOUND)
        message(
            STATUS "cpu_features package not found. Requiring cpu_features submodule ...")
        if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cpu_features/CMakeLists.txt")
            message(
                FATAL_ERROR
                    "cpu_features/CMakeLists.txt not found. Did you forget to git clone recursively?\nFix with: git submodule update --init"
            )
        endif()
        message(STATUS "Building Volk with cpu_features")
        set(BUILD_TESTING
            OFF
            CACHE BOOL "Build cpu_features without tests." FORCE)
        set(BUILD_PIC
            ON
            CACHE BOOL "Build cpu_features with Position Independent Code (PIC)." FORCE)
        set(CMAKE_POSITION_INDEPENDENT_CODE
            ON
            CACHE BOOL "Build cpu_features with Position Independent Code (PIC)." FORCE)
        set(BUILD_SHARED_LIBS_SAVED "${BUILD_SHARED_LIBS}")
        set(BUILD_SHARED_LIBS OFF)
        set(ENABLE_INSTALL OFF)
        add_subdirectory(cpu_features)
        set(BUILD_SHARED_LIBS "${BUILD_SHARED_LIBS_SAVED}")
    endif()
else()
    message(STATUS "Building Volk without cpu_features")
endif()

# Python
include(VolkPython) #sets PYTHON_EXECUTABLE and PYTHON_DASH_B
volk_python_check_module("python >= 3.4" sys "sys.version_info >= (3, 4)"
                         PYTHON_MIN_VER_FOUND)
volk_python_check_module("mako >= 0.4.2" mako "mako.__version__ >= '0.4.2'" MAKO_FOUND)

if(NOT PYTHON_MIN_VER_FOUND)
    message(FATAL_ERROR "Python 3.4 or greater required to build VOLK")
endif()

# Mako
if(NOT MAKO_FOUND)
    message(FATAL_ERROR "Mako templates required to build VOLK")
endif()

# Check if we have std::filesystem
find_package(
    FILESYSTEM
    COMPONENTS Final Experimental
    REQUIRED)

set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################
# check for aligned_alloc, since some compilers lack this C11 feature.
# For Apple-clang use `posix_memalign`
# For MSVC use `_aligned_malloc`.
########################################################################
include(CheckSymbolExists)
if(NOT (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
    check_symbol_exists(aligned_alloc stdlib.h USE_ALIGNED_ALLOC)
endif()
if(NOT USE_ALIGNED_ALLOC)
    check_symbol_exists(posix_memalign stdlib.h HAVE_POSIX_MEMALIGN)
endif()

########################################################################
# Check if Orc is available
########################################################################
option(ENABLE_ORC "Enable Orc" True)
if(ENABLE_ORC)
    find_package(ORC)
else(ENABLE_ORC)
    message(STATUS "Disabling use of ORC")
endif(ENABLE_ORC)

########################################################################
# Setup doxygen
########################################################################
add_subdirectory(docs)

########################################################################
# Detect /lib versus /lib64
########################################################################
include(GNUInstallDirs)

########################################################################
# Setup the package config file
########################################################################
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tmpl/volk.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/volk.pc @ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/volk.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT "volk_devel")

########################################################################
# Install all headers in the include directories
########################################################################
set(VOLK_RUNTIME_DIR bin)
set(VOLK_LIBRARY_DIR ${CMAKE_INSTALL_LIBDIR})
set(VOLK_INCLUDE_DIR include)

install(
    DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/kernels/volk
    DESTINATION include
    COMPONENT "volk_devel"
    FILES_MATCHING
    PATTERN "*.h")

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_prefs.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_alloc.hh
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_complex.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_common.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/saturation_arithmetic.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_avx_intrinsics.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_avx2_intrinsics.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_avx2_fma_intrinsics.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_sse_intrinsics.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_sse3_intrinsics.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_neon_intrinsics.h
          ${CMAKE_CURRENT_BINARY_DIR}/include/volk/volk.h
          ${CMAKE_CURRENT_BINARY_DIR}/include/volk/volk_cpu.h
          ${CMAKE_CURRENT_BINARY_DIR}/include/volk/volk_config_fixed.h
          ${CMAKE_CURRENT_BINARY_DIR}/include/volk/volk_typedefs.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/volk_malloc.h
          ${CMAKE_CURRENT_BINARY_DIR}/include/volk/volk_version.h
          ${CMAKE_CURRENT_SOURCE_DIR}/include/volk/constants.h
    DESTINATION include/volk
    COMPONENT "volk_devel")

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${VOLK_LIBRARY_DIR}
            CACHE PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${VOLK_LIBRARY_DIR}
            CACHE PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH
            ON
            CACHE BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Create uninstall target
########################################################################
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake @ONLY)

# Only add the target if there isn't one defined already
if(NOT TARGET uninstall)
    add_custom_target(uninstall ${CMAKE_COMMAND} -P
                                ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

########################################################################
# Install our Cmake modules into $prefix/lib/cmake/volk
# See "Package Configuration Files" on page:
# https://gitlab.kitware.com/cmake/community/-/wikis/doc/tutorials/Packaging
########################################################################

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/VolkConfig.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/cmake/Modules/VolkConfig.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/VolkConfigVersion.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/cmake/Modules/VolkConfigVersion.cmake @ONLY)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -93,19 +93,35 @@
     OUTPUT_VARIABLE arch_flag_lines
     OUTPUT_STRIP_TRAILING_WHITESPACE)
 
+try_compile(
+    HAVE_RVV_INTRINSICS
+    ${CMAKE_BINARY_DIR}
+    ${CMAKE_SOURCE_DIR}/cmake/Checks/check-rvv-intrinsics.c
+)
+if(HAVE_RVV_INTRINSICS)
+    message(STATUS "Checking RVV intrinsics - found")
+else()
+    message(STATUS "Checking RVV intrinsics - not found")
+endif()
+
 macro(check_arch arch_name)
     set(flags ${ARGN})
     set(have_${arch_name} TRUE)
+
+    string(SUBSTRING "${arch_name}" 0 2 arch_prefix)
     foreach(flag ${flags})
         if(MSVC AND (${flag} STREQUAL "/arch:SSE2" OR ${flag} STREQUAL "/arch:SSE"))
             # SSE/SSE2 is supported in MSVC since VS 2005 but flag not available when compiling 64-bit so do not check
+        elseif("${arch_prefix}" STREQUAL "rv" AND NOT HAVE_RVV_INTRINSICS)
+            message(STATUS "Skipping ${arch_name} due to missing RVV intrinsics support")
+            set(have_${arch_name} FALSE)
         else()
             include(CheckCXXCompilerFlag)
             set(have_flag have${flag})
             #make the have_flag have nice alphanum chars (just for looks/not necessary)
             execute_process(
                 COMMAND ${PYTHON_EXECUTABLE} -c
-                        "import re; print(re.sub('\\W', '_', '${have_flag}'))"
+                        "import re; print(re.sub(r'\\W', '_', '${have_flag}'))"
                 OUTPUT_VARIABLE have_flag
                 OUTPUT_STRIP_TRAILING_WHITESPACE)
             if(VOLK_FLAG_CHECK_FLAGS)
@@ -255,17 +271,16 @@
 ########################################################################
 if(NOT CROSSCOMPILE_MULTILIB AND CPU_IS_x86)
     include(CheckTypeSize)
-    check_type_size("void*[8]" SIZEOF_CPU BUILTIN_TYPES_ONLY)
-    if(${SIZEOF_CPU} EQUAL 64)
+    cmake_host_system_information(RESULT ASSUME_64BIT_HOST QUERY IS_64BIT)
+    if(ASSUME_64BIT_HOST)
         overrule_arch(32 "CPU width is 64 bits")
-    endif()
-    if(${SIZEOF_CPU} EQUAL 32)
+    else()
         overrule_arch(64 "CPU width is 32 bits")
     endif()
 
     #MSVC 64 bit does not have MMX, overrule it
     if(MSVC)
-        if(${SIZEOF_CPU} EQUAL 64)
+        if(ASSUME_64BIT_HOST)
             overrule_arch(mmx "No MMX for Win64")
         endif()
         force_arch(sse "Built-in for MSVC > 2013")
@@ -295,15 +310,3 @@
 ########################################################################
 # determine available machines given the available architectures
 ########################################################################
-execute_process(
-    COMMAND
-        ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
-        ${PROJECT_SOURCE_DIR}/gen/volk_compile_utils.py --mode "machines" --archs
-        "${available_archs}"
-    OUTPUT_VARIABLE available_machines
-    OUTPUT_STRIP_TRAILING_WHITESPACE)
-
-########################################################################
-# Implement machine overruling for redundant machines:
-# A machine is redundant when expansion rules occur,
-# and the arch superset passes configuration checks.

=== python/volk_modtool/CMakeLists.txt ===
#
# Copyright 2013, 2014 Free Software Foundation, Inc.
#
# This file is part of VOLK
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#

########################################################################
# Install python files and apps
########################################################################
include(VolkPython)

volk_python_install(
    FILES
    __init__.py
    cfg.py
    volk_modtool_generate.py
    DESTINATION
    ${VOLK_PYTHON_DIR}/volk_modtool
    COMPONENT
    "volk")

volk_python_install(PROGRAMS volk_modtool DESTINATION ${VOLK_RUNTIME_DIR} COMPONENT
                    "volk")

=== debian/changelog ===
volk (3.2.0-3) unstable; urgency=medium

  * update to v3.2.0-15-gf9d2ed6
    (except cx-limited-range-Scope-compile-feature)
  * Standards-Version 4.7.2 no changes
  * pass on known test failures (Closes: #1098070)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 19 Sep 2025 19:15:06 -0400

volk (3.2.0-2) unstable; urgency=medium

  * upload to unstable
  * Standards-Version 4.7.1 no changes

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 24 Feb 2025 20:17:13 -0500

volk (3.2.0-1) experimental; urgency=medium

  * New upstream release.
  - New and improved kernels
     - add RISC-V Vector extension (RVV) kernels
     - New AVX512F implementation
  - Improved builds
     - cmake: Fix 64bit host CPU detection
     - cmake: Suppress invalid escape sequence warnings with Python 3.12
     - cmake/pkgconfig: use CMAKE_INSTALL_FULL_* variables
     - cmake: Fix VOLK as a submodule build issue
     - Adds toolchain file for Raspberry Pi 5
  - New and improved tests
     - gtest: Start work on new test infrastructure
     - tests: Add a log info print test
     - gtest: Make gtest an install dependency
     - gtest: Enable GTests in CI workflows
     - tests: Beautify test output
  - Documentation
     - cpu_features: Update hints in README
  - Code quality
     - Add const to several args
  - Usability features
     - feature: add env variable kernel override
  * update Standards-Version (no changes)
  * upload to experimental for library soversion change.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 03 Feb 2025 22:07:56 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: volk
 Section: libdevel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: A. Maitland Bottoms <bottoms@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), cmake,
+Maintainer: A. Maitland Bottoms <bottoms@debian.org>
+Build-Depends: cmake,
                debhelper-compat (= 13),
                dh-python,
                libcpu-features-dev [amd64 arm64 armel armhf i386 mips64el ppc64 ppc64el riscv64 s390x powerpc x32],
@@ -11,16 +10,13 @@
                python3-dev,
                python3-mako
 Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://libvolk.org
 Vcs-Browser: https://salsa.debian.org/bottoms/pkg-volk
 Vcs-Git: https://salsa.debian.org/bottoms/pkg-volk.git
 
-Package: libvolk3.1t64
-Provides: ${t64:Provides}
-Replaces: libvolk3.1
-Breaks: libvolk3.1 (<< ${source:Version})
+Package: libvolk3.2
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -37,7 +33,7 @@
 Package: libvolk-dev
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk3.1t64 (=${binary:Version}), ${misc:Depends}
+Depends: libvolk3.2 (=${binary:Version}), ${misc:Depends}
 Breaks: libvolk1-dev, libvolk1.0-dev, libvolk2-dev
 Replaces: libvolk1-dev, libvolk1.0-dev, libvolk2-dev
 Suggests: libvolk-doc
@@ -55,8 +51,7 @@
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk3.1t64 (=${binary:Version}),
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
 Breaks: libvolk1-bin, libvolk1.0-bin, libvolk2-bin

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 #export DEB_BUILD_MAINT_OPTIONS += hardening=+all
+export DEB_BUILD_MAINT_OPTIONS += hardening=-all
 #export DH_VERBOSE=1
 
 %:
@@ -14,6 +15,11 @@
 	dh_auto_install
 	find debian -type d -empty -delete
 
+# Known test failures of qa_volk_32fc_s32fc_rotator2puppet_32fc
+# is being reviewed upstream (github issue 794, pull request 795)
+override_dh_auto_test:
+	- dh_auto_test
+
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf gen/__pycache__

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,uversionmangle=s/-rc/~rc/" \
 https://github.com/gnuradio/volk/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
